Attribute VB_Name = "utils"
' Paul McMahon 2007

Option Explicit


Private Declare Function GetSaveFileName Lib "comdlg32.dll" Alias _
         "GetSaveFileNameA" (pOpenfilename As OPENFILENAME) As Long

Private Type OPENFILENAME
  lStructSize As Long
  hwndOwner As Long
  hInstance As Long
  lpstrFilter As String
  lpstrCustomFilter As String
  nMaxCustFilter As Long
  nFilterIndex As Long
  lpstrFile As String
  nMaxFile As Long
  lpstrFileTitle As String
  nMaxFileTitle As Long
  lpstrInitialDir As String
  lpstrTitle As String
  flags As Long
  nFileOffset As Integer
  nFileExtension As Integer
  lpstrDefExt As String
  lCustData As Long
  lpfnHook As Long
  lpTemplateName As String
End Type
       
 ' Constants for File Open/Save Flags
Const OFN_ALLOWMULTISELECT = &H200
'Allow the user to select multiple files (Open File dialog box only).
Const OFN_CREATEPROMPT = &H2000
'Prompt if a non-existing file is chosen.
Const OFN_ENABLEHOOK = &H20
'Use the function specified by lpfnHook to process the dialog box's messages.
Const OFN_ENABLETEMPLATE = &H40
'Use the dialog box template specifed by hInstance and lpTemplateName.
Const OFN_ENABLETEMPLATEHANDLE = &H80
'Use the preloaded dialog box template specified by hInstance.
Const OFN_EXTENSIONDIFFERENT = &H400
'The function sets this flag if the user selects a file with an extension different than the one specified by lpstrDefExt.
Const OFN_FILEMUSTEXIST = &H1000
'Only allow the selection of existing files.
Const OFN_HIDEREADONLY = &H4
'Hide the Open As Read Only check box (Open File dialog box only).
Const OFN_NOCHANGEDIR = &H8
'Don 't change Windows's current directory to match the one chosen in the dialog box.
Const OFN_NODEREFERENCELINKS = &H100000
'If a shortcut file (.lnk or .pif) is chosen, return the shortcut file itself instead of the file or directory it points to.
Const OFN_NONETWORKBUTTON = &H20000
'Hide and disable the Network button in the dialog box.
Const OFN_NOREADONLYRETURN = &H8000
'The function sets this flag if the selected file is not read-only (Open File dialog box only).
Const OFN_NOVALIDATE = &H100
'Don 't check the filename for invalid characters.
Const OFN_OVERWRITEPROMPT = &H2
'Prompt the user if the chosen file already exists (Save File dialog box only).
Const OFN_PATHMUSTEXIST = &H800



 


Function putfile(Myhwnd As Long, sFilter As String, sDefExt As String) As String
' browse to return a filename and path of a file which doesn't have to exist to for example open to write to
' sFilter contains the search string, if null defaults to *.txt
' sDefExt contains the default extention if null defaults to TXT
' MyHwnd contains the windows handle of the calling app, usually the main form eg. form1.hwnd.

' if user cancels then returns a null string

  Dim OpenFile As OPENFILENAME
  Dim lReturn As Long
  If sFilter = "" Then
    sFilter = "Text (*.TXT)" & Chr(0) & "*.TXT" & Chr(0)
  End If
  If sDefExt = "" Then
    sDefExt = "TXT"
  End If
  OpenFile.lStructSize = Len(OpenFile)
  OpenFile.hwndOwner = Myhwnd
  OpenFile.hInstance = App.hInstance
  OpenFile.lpstrFilter = sFilter
  OpenFile.nFilterIndex = 1
  OpenFile.lpstrFile = String(257, 0)
  OpenFile.nMaxFile = Len(OpenFile.lpstrFile) - 1
  OpenFile.lpstrFileTitle = OpenFile.lpstrFile
  OpenFile.nMaxFileTitle = OpenFile.nMaxFile
  OpenFile.lpstrInitialDir = App.Path
  OpenFile.lpstrTitle = "Select Output File"
  OpenFile.flags = OFN_OVERWRITEPROMPT
  OpenFile.lpstrDefExt = sDefExt
  lReturn = GetSaveFileName(OpenFile)
  If lReturn = 0 Then
     putfile = ""
  Else
     putfile = Trim(OpenFile.lpstrFile)
  End If
End Function


