Define CONF_WORD = 0x3f72

'Paul McMahon Simple Analog Data Aquisition
'April,May 2008


'Defines

Define ADC_CLOCK = 3  'Use A/D with internal RC clock
Define ADC_SAMPLEUS = 20  'default value is 20

Define LCD_BITS = 8  'use 8 Bit interface
Define LCD_DREG = PORTD  'LCD data is on port D
Define LCD_DBIT = 0  '0 or 4 for 4-bit interface, ignored for 8-bit interface
Define LCD_RSREG = PORTB  'Control lines on Port B
Define LCD_RSBIT = 0
Define LCD_EREG = PORTB
Define LCD_EBIT = 2
Define LCD_RWREG = PORTB
Define LCD_RWBIT = 1
Define LCD_COMMANDUS = 5000  'delay after LCDCMDOUT, default value is 5000
Define LCD_DATAUS = 100  'delay after LCDOUT, default value is 100
Define LCD_INITMS = 100  'delay used by LCDINIT, default value is 100
Define LCD_READ_BUSY_FLAG = 1  'Ignore the timers above and just check the busy flag

TRISB = %11111000  'set PORTB pins 0,1,2 as outputs, rest as inputs
OPTION.NOT_RBPU = 0  'set pull ups for port B inputs on
TRISA = %11111111  'set all PORTA pins as inputs
ADCON1 = 0x8d  'set PORTA pins 0 and 1 as analog inputs result as right shifted
'plus use ports 2 & 3 for lower and upper reference respectively


'PORT B pin assignment Pull up set on ie. earth = 0, float = 1
'Bit 7 & 6 Divisor set 00 = 11, 10 = 10, 01 = 13, 11 = 12
'Bit 5 & 4 Average set 00 = both 1, 10 = O4 A2, 01 = O8 A4, 11 = O16 A8
'Bit 3 Diags 0 = Diag display, 1 = Normal

Dim myvin As Word
Dim myoffset As Word

Dim math1 As Word
Dim math2 As Word
Dim math3 As Word
Dim math4 As Word
Dim math5 As Word

Dim mycntr1 As Byte
Dim mycntr2 As Byte
Dim mydiv As Byte
Dim mysgn As Byte
Dim myoav As Byte
Dim myaav As Byte

Lcdinit  'initialize LCD module; cursor is off
Hseropen 9600  'initialize USART module (8 bit, 9600 baud rate, no parity bit...
WaitMs 1000  'wait for everything to stablize.

mycntr1 = 0
mycntr2 = 0
myoffset = 0
myvin = 0
math4 = 0
math5 = 0


loop:
	mydiv = 0
	mydiv.0 = PORTB.5
	mydiv.1 = PORTB.4

	Select Case mydiv
	Case %00000000
		myoav = 1
		myaav = 1
	Case %00000001
		myoav = 4
		myaav = 2
	Case %00000010
		myoav = 8
		myaav = 4
	Case %00000011
		myoav = 16
		myaav = 8
	Case Else
	EndSelect


	mydiv = 0
	mydiv.0 = Not PORTB.7
	mydiv.1 = PORTB.6
	mydiv = mydiv + 10
	

	Lcdcmdout LcdClear

	Adcin 0, math3
	If mycntr1 < myoav Then  'average offset input for myoav samples
		math4 = math4 + math3
		mycntr1 = mycntr1 + 1
	Else
		myoffset = math4 / myoav
		mycntr1 = 0
		math4 = 0
	Endif
	
	Adcin 1, math3
	Hserout "VA1 = ", #math3, CrLf  'send out raw count to PC
	If mycntr2 < myaav Then  'average voltage input for myaav samples
		math5 = math5 + math3
		mycntr2 = mycntr2 + 1
	Else
		myvin = math5 / myaav
		mycntr2 = 0
		math5 = 0
	Endif

'Display current values

	math1 = myoffset Mod mydiv
	math1 = math1 * 10
	math1 = math1 / mydiv
	math2 = myoffset / mydiv
	If PORTB.3 Then  'do normal print
		Lcdout "Offset: -", #math2, ".", #math1, " dB"
	Else  'do diagnostic print
		Lcdout "I", #math2, ".", #math1, " D", #mydiv, " O", #myoav, " A", #myaav
	Endif
	Lcdcmdout LcdLine2Home
	math2 = myvin - myoffset
	If math2 > 32768 Then
		mysgn = "-"
		math2 = 65535 - math2 + 1
	Else
		mysgn = "+"
	Endif
	math1 = math2 Mod mydiv
	math1 = math1 * 10
	math1 = math1 / mydiv
	math2 = math2 / mydiv
	Lcdout " Value: ", mysgn, #math2, ".", #math1, "dBm"

'Do samples every 25 ms
	WaitMs 25


Goto loop
